var widget_demo_property = StudioWidgetWrapper.extend({
    /*
     * Triggered when initializing a widget and will have the code that invokes rendering of the widget
     */
    init : function()
    {
        var thisObj = this;
        thisObj._super.apply(thisObj, arguments);
        thisObj.render();
        if((typeof(Studio) != "undefined") && Studio)
        {
            /*
             * Register custom event or action here, and trigger the event afterwards.
             * Studio.registerEvents(thisObj, "", "", EventConfig), 
             * Studio.registerAction(thisObj, "", "", ActionConfig, $.proxy(this.Cbk, this), );
             * thisObj.triggerEvent("", )
             */
        }
    },
    
    /*
     * Triggered from init method and is used to render the widget
     */
    render : function()
    {
        var thisObj = this;
        var widgetProperties = thisObj.getProperties();
        var elem = thisObj.getContainer();
        var items = thisObj.getItems();
        var connectorProperties = thisObj.getConnectorProperties();
        
        /*
         * API to get base path of your uploaded widget API file
         */
        var widgetBasePath = thisObj.getWidgetBasePath();
        if(elem)
        {
            var vm = new Vue({
				el: $("#widget_demo_property", elem)[0],
				data: {
                    form: {
						textProperty: widgetProperties.textProperty,
					    checkboxProperty: widgetProperties.checkboxProperty,
					    selectProperty: widgetProperties.selectProperty
					}
				}
			})
        }
        
        /*
         * API to bind global events to the item DOM, it should not be deleted if there will some events to trigger in this widget.
         */
        thisObj.sksBindItemEvent();
        
        /*
         * API to refresh the previously bound events when a resize or orientation change occurs.
         */
        $(window).resize(function() {
            thisObj.sksRefreshEvents();
        });
    },
});